

%{
/*
    This file is part of ipclassify.

    ipclassify is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ipclassify is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ipclassify.  If not, see <http://www.gnu.org/licenses/>.
*/
  /* Definition Section of parser */
#include <stdio.h>
#include "basic.h"

#ifdef DMALLOC
#include "dmalloc.h"
#endif

extern void loadfile(int, char *,int);

char *FileName = NULL;

%}

%union {
  int intval;
  char *textval;
}

%token MARK
%token ACCEPTMARK
%token REJECTMARK
%token WHITELIST
%token <intval> NUMBER
%token <textval> FILENAME

%%
  /* Rules Section */
  queues: 
    | queues queue
    | queue
    ;
    
  queue: NUMBER WHITELIST FILENAME ';' 
  { loadfile($1,FileName,TRUE); free(FileName); FileName = NULL;}
  | queue: NUMBER FILENAME ';'
  { loadfile($1,FileName,FALSE); free(FileName); FileName = NULL;}
  | NUMBER REJECTMARK MARK NUMBER ';'
  { setMark(FALSE,$1,$4); }
  | NUMBER ACCEPTMARK MARK NUMBER ';'
  { setMark(TRUE,$1,$4); }
  ; 
  
%%

int yywrap(void) {
  return(1);
}
  
